/* Copyright (C) 1994 
            Olav Woelfelschneider (wosch@rbg.informatik.th-darmstadt.de)

 This library is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _McBitmap_h_
#define _McBitmap_h_

typedef struct McBitmap {
  struct McBitmap *next;
  Pixmap pixmap;
  Pixmap shape;
  void *bits;
  int width,height;
  int x,y;
  unsigned short depth, flags;
} McBitmap;

extern McBitmap *McCreateBitmap(McWindow *mcw, int x, int y, char *bits,
				int w, int h);

extern McBitmap *McCreateBitmapFromData(McWindow *mcw, McBitmap *bitmap);
extern Pixmap McCreatePixmapFromImage(McWindow *mcw, XImage *ximage);

extern void McFreeBitmap(McApp *app, McBitmap *bitmap);
extern void McPutBitmap(McWindow *mcw, Window win,
			McBitmap *bitmap, GC gc, int x, int y);



#define MCBM_STATIC     1
#define MCBM_STATICBITS 2
#define MCBM_XPM        4

#define MCBITMAP(b,w,h,x,y) { NULL, 0, 0, b, w, h, x, y, 1,\
			      MCBM_STATIC | MCBM_STATICBITS }
#define MCPIXMAP(b,x,y)     { NULL, 0, 0, b, 0, 0, x, y, 0,\
			      MCBM_STATIC | MCBM_STATICBITS | MCBM_XPM }

#endif /* _McBitmap_h_ */

